//Training a binary classifier on a data set. This code trains a model of binary classifier by using a data set read from STDIN, and writes the resultant model to STDOUT. This code assumes that features in the data set are represented by integer identifiers.
/*
 *      A sample program for training a binary classifier.
 *
 * Copyright (c) 2008,2009 Naoaki Okazaki
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the names of the authors nor the names of its contributors
 *       may be used to endorse or promote products derived from this
 *       software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/* $Id: train_binary_batch.cpp 180 2009-09-25 08:51:06Z naoaki $ */

/*
 * This file was modified from train_binary_batch.cpp (info above) 
 * by Kevin Gimpel.
 * Copyright 2010-2012 Kevin Gimpel
 * Released under the modified BSD license. See the LICENSE file included with this distribution.
 */

#ifndef CLASSIAS_BINARY_CLASSIFIER_H_
#define CLASSIAS_BINARY_CLASSIFIER_H_

#include <vector>

#include "classias/classias.h"
#include "classias/classify/linear/binary.h"
#include "classias/train/lbfgs.h"

using namespace std;

class ClassiasBinaryClassifier {
	public:
		// TODO: use int->int quark instead of string->int quark!
		ClassiasBinaryClassifier();
		void addTrainingExample(const map<int, double>& featureVector, bool label);
		void train(int maxNumIterations, double c1, double c2);

		map<int, double> m_sparseWeightVector;

	private:
		classias::train::lbfgs_logistic_binary<classias::bsdata> m_lbfgsLogisticRegressionClassifier;
		classias::bsdata m_data;
};

#endif

